Raven.context(function() {
	// Avoid `console` errors in browsers that lack a console.
	(function() {
		window.console = window.console || {};
	    var methods = [
	        'assert', 'clear', 'count', 'debug', 'dir', 'dirxml', 'error',
	        'exception', 'group', 'groupCollapsed', 'groupEnd', 'info', 'log',
	        'markTimeline', 'profile', 'profileEnd', 'table', 'time', 'timeEnd',
	        'timeline', 'timelineEnd', 'timeStamp', 'trace', 'warn'
	    ];
		var noop = function() {};

		for (var i = methods.length; i > 0; i--) {
			// Only stub out undefined methods
			window.console[methods[i]] = window.console[methods[i]] || noop;
		}
	}());

(function($) {
if(! window['wfKeys']){
window['wfKeys'] = {
	haveError: false,
	cimPurchaseBusy: false,
	loadingCount: 0,
	keySort: 'site',
	keySortOrder: 'asc',
	cardLastFour: '',
	buyMoreTimeBusy: false,
	refundProcessing: false,
	init: function($) {
		if(jQuery('#wfKeyListDiv').length > 0){
			this.loadKeys();
		}
		if(jQuery('#element_pricePerKey').length > 0){
			this.initKeyPrice();
		}

		if ($('#signup').length > 0) {
			var self = this;
			paypal.Button.render({
				env: (WFKVars.paypalSandbox ? 'sandbox' : 'production'),
				style: {
					size: 'small',
					color: 'silver',
					shape: 'rect'
				},

				payment: function(resolve, reject) {
					wfKeys.validateSignup(true,
						function(response) {
							resolve(response.paymentID);
						},
						function(err) {
							reject(err);
						});
				},

				onAuthorize: function(data) {
					self.finalizePayPalPremiumKey(data.paymentID, data.payerID, function(ret) {
						$('#wfSignupAjaxLoading').hide();
						if (ret.err) {
							self.addError('general', ret.err);
							this.showGlobalError();
							return;
						}
						else if (ret.ok) {
							if (ret.logAnalytics) {
								self.logAnalyticsTransaction("New API Key", "New API Key", ret.timePeriod, ret.totalPrice, ret.quantity, ret.transactionID, "Wordfence Signup");
								self.logOptimizely('newPurchases', ret.totalPrice * 100);
								setTimeout(function(){
									window.location.href = ret.destination;
								}, 1000); //Give analytics time to log
							}
							else {
								window.location.href = ret.destination;
							}
							return;
						} else {
							alert("An error occurred. You can try resubmitting your form or try reloading this page and then starting over.");
							return;
						}
					});
				},

				onCancel: function(data) {
					$('#wfSignupAjaxLoading').hide();
				},

				onError: function(data) {
					$('#wfSignupAjaxLoading').hide();
				}

			}, '#payPalWrapper');
		}

		// Checkout form
		var self = this;
		jQuery('form.checkout-form .paypal-fields').hide();
		jQuery('form.checkout-form input[name=payment_method]').on('change', function () {
			if (jQuery('form.checkout-form input[name=payment_method]:checked').val() === 'paypal') {
				jQuery('form.checkout-form .cc-fields').slideUp();
				jQuery('form.checkout-form .paypal-fields').slideDown();
			} else {
				jQuery('form.checkout-form .cc-fields').slideDown();
				jQuery('form.checkout-form .paypal-fields').slideUp();
			}
		});
		if (this.useCardOnFile()) {
			jQuery('form.checkout-form .new-card, form.checkout-form .new-method-choice').hide();
		}
		jQuery('form.checkout-form input[name=element_cardOnFile]').on('change', function () {
			if (jQuery('form.checkout-form input[name=element_cardOnFile]:checked').val() === '1') {
				jQuery('form.checkout-form input[name=payment_method][value=credit-card]').prop('checked', true).trigger('change');

				jQuery('form.checkout-form .new-card, form.checkout-form .new-method-choice').slideUp();
				jQuery('form.checkout-form .card-on-file').slideDown();
			} else {
				jQuery('form.checkout-form .new-card, form.checkout-form .new-method-choice').slideDown();
				jQuery('form.checkout-form .card-on-file').slideUp();
			}
		});

		jQuery('#checkout-signin').on('click', function() {
			jQuery.ajax({
				type: 'GET',
				url: 'https://www.wordfence.com/sign-in?modalLogin=1&signinOnly=1',
				dataType: "html",
				success: function(html) {
					self.showModal(html, function() {

					}, 'modal-signin');
				},
				error: function(obj, text, err) {
					throw(err);
				}
			});
		});
		jQuery(window).on('wflogin:success', function() {
			self.hideModal();
			self.ajax('wfCheckoutAccountInfo', {}, function(json) {
				if (json.accountInfo) {
					document.location.reload(true);
				}
			});
		});
		jQuery('form.checkout-form').on('submit', function () {
			return self.validateCheckout();
		});
		jQuery('#element_country').on('change', function() {
			var country = jQuery(this).val();
			var preferredPostalTerm = jQuery('#element_country_' + country).data('postal');
			if (!preferredPostalTerm) {
				jQuery('#element_zip').closest('div').hide();
			}
			else {
				jQuery('#element_zip').closest('div').show();
				jQuery('label[for=element_zip]').text(preferredPostalTerm);
			}

			var wantsVAT = !!jQuery('#element_country_' + country).data('vat');
			if (wantsVAT) {
				jQuery('#element_vat').closest('div.row').show();
			}
			else {
				jQuery('#element_vat').closest('div.row').hide();
			}
		});
		jQuery('#element_country').trigger('change');
		jQuery('#element_cardNumber').payment('formatCardNumber');
		jQuery('#element_cardExpiry').payment('formatCardExpiry');
		jQuery('#element_cardCode').payment('formatCardCVC');
	},
	showModal: function(content, callback, size) {
		var self = this;
		var wHeight = jQuery(window).height();
		var maxHeight = (wHeight - 100) + 'px';
		var modal = jQuery('<div class="wfkModal new"><div><div><div class="container"><div class="modal-content '+size+'" style="max-height:'+maxHeight+';"><a href="#" class="close-modal">&#x2421;</a></div></div></div></div></div>');

		// Close event handlers
		jQuery(modal).on('click', '.close-modal, .wfkModal', this.hideModal);
		jQuery(document).on('keyup', function(e) {
			if (e.keyCode == 27) {
				self.hideModal();
			}
		});

		jQuery('.modal-content', modal).append(content);
		jQuery('body').append(modal);
		jQuery('body').css({'overflow':'hidden'}).delay(50).find('.wfkModal:not(.new)').remove();
		jQuery('.wfkModal.new').delay(50).fadeIn(function(){
			jQuery(this).removeClass('new');
		});

		if (typeof callback == "function") {
			callback();
		}
	},
	hideModal: function(e) {
		jQuery('body').css({'overflow':'auto'});
		jQuery('.wfkModal').fadeOut(function() {
			jQuery(this).remove();
		});
		return false;
	},
	currencyRound: function(value, digits) {
		return +value.toFixed(digits);
	},
	resendCode: function(phone, method){
		this.ajax('wfResendCode', {
			phone: phone,
			method: method
			}, function(ret){ alert("Your code was resent. If you don't receive it, try another method and hit the send button again."); });
	},
	sortKeys: function(key){
		if(this.keySort == key){
			if(this.keySortOrder == 'asc'){
				this.keySortOrder = 'desc';
			} else {
				this.keySortOrder = 'asc';
			}
		} else {
			this.keySortOrder = 'asc';
		}
		this.keySort = key;
		this.loadKeys();
	},
	getQueryParameterByName: function(name, url) {
		if (!url) url = window.location.href;
		name = name.replace(/[\[\]]/g, "\\$&");
		var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
			results = regex.exec(url);
		if (!results) return null;
		if (!results[2]) return '';
		return decodeURIComponent(results[2].replace(/\+/g, " "));
	},
	initKeyPrice: function() {
		var defaultCount = parseInt(this.getQueryParameterByName('defaultCount'));
		if (defaultCount === null || isNaN(defaultCount)) { defaultCount = 3; }
		var defaultDuration = parseInt(this.getQueryParameterByName('defaultDuration'));
		if (defaultDuration === null || isNaN(defaultDuration)) { defaultDuration = 3; }
		jQuery('#element_pricePerKey').attr('readonly', 'readonly');
		jQuery('#element_totalPrice').attr('readonly', 'readonly');
		jQuery('#element_numKeys_selector a[data-value="' + defaultCount + '"]').closest('li').addClass('active');
		jQuery('#element_numKeys').val(defaultCount);
		jQuery('#element_numYears_selector a[data-value="' + defaultDuration + '"]').closest('li').addClass('active');
		jQuery('#element_numYears').val(defaultDuration);
		this.updateKeyPrice();

		$('#element_numKeys_custom').on('keyup', function(e) {
			var val = $(this).val();
			var replacedVal = val.replace(/[^0-9]/g, '');
			if (val != replacedVal) {
				$(this).val(replacedVal);
			}
			$('#element_numKeys').val(replacedVal);
			$('#element_numKeys_selector li').removeClass('active');
			wfKeys.updateKeyPrice();
		});

		jQuery('#element_numKeys').keyup(function() {
			var val = jQuery(this).val();
			var replacedVal = val.replace(/[^0-9]/g, '');
			if (val != replacedVal) {
				jQuery(this).val(replacedVal);
			}
			wfKeys.updateKeyPrice();
		});

		$('#element_numKeys_selector a').on('click', function(e) {
			e.preventDefault();
			e.stopPropagation();

			var container = $(this).closest('ul');
			$(container).find('li').each(function(i, e) {
				$(e).removeClass('active');
			});
			$(this).closest('li').addClass('active');
			$('#element_numKeys_custom').val('');
			$('#element_numKeys').val($(this).data('value'));
			wfKeys.updateKeyPrice();
		});

		$('#element_numYears_selector a').on('click', function(e) {
			e.preventDefault();
			e.stopPropagation();

			var container = $(this).closest('ul');
			$(container).find('li').each(function(i, e) {
				$(e).removeClass('active');
			});
			$(this).closest('li').addClass('active');
			$('#element_numYears').val($(this).data('value'));
			wfKeys.updateKeyPrice();
		});

		jQuery('#element_numYears').change(function(){ wfKeys.updateKeyPrice(); });
		this.updateKeyPrice();
	},
	showLoading: function(){
		this.loadingCount++;
		if(this.loadingCount == 1){
			jQuery('<div id="wfKeysWorking"><div class="wfKeysWorkingInner">Working...</div></div>').appendTo('body');
		}
	},
	removeLoading: function(){
		this.loadingCount--;
		if(this.loadingCount == 0){
			jQuery('#wfKeysWorking').remove();
		}
	},
	doRefund: function(transID, userID, amount){
		this.showModal(jQuery('#wfDoRefundTmpl').tmpl({ transID: transID, userID: userID, amount: amount }));
	},
	doRefundTwo: function(transID, userID){
		if(this.refundProcessing){ return; }
		this.refundProcessing = true;
		var amount = jQuery('#wfRefundAmount').val();
		var description = jQuery('#wfRefundDesc').val();
		var self = this;
		this.showLoading();
		this.ajax('wfDoRefund', {
			transID: transID,
			userID: userID,
			amount: amount,
			description: description
			}, function(ret){ self.removeLoading(); self.refundProcessing = false; self.doRefundComplete(ret); });
	},
	doRefundComplete: function(ret){
		this.showModal(jQuery('#wfDoRefundResultTmpl').tmpl({ result: ret.result }));
	},
	doCIMPurchase: function(buttonElem){
		if(this.cimPurchaseBusy){ return; }
		this.cimPurchaseBusy = true;
		jQuery('#cimAjax').show();
		var self = this;
		this.ajax('wfCIMPurchase', {
			pricePerKey: jQuery('#element_pricePerKey').val(),
			totalPrice: jQuery('#element_totalPrice').val(),
			numKeys: jQuery('#element_numKeys').val(),
			numYears: jQuery('#element_numYears').val()
			}, function(ret){ self.cimPurchaseDone(ret); });
	},
	cimPurchaseDone: function(ret){
		if(ret.err){
			this.cimPurchaseBusy = false;
			this.showModal(jQuery('#wfErrTmpl').tmpl(ret));
			return;
		} else if(ret.ok){
			this.loadKeys();
			this.showModal(jQuery('#wfThanksForPurchaseTmpl').tmpl(ret));
			this.cimPurchaseBusy = false;
			if(ret.logAnalytics){
				this.logAnalyticsTransaction("More API Keys", "More API Keys", ret.timePeriod, ret.totalPrice, ret.quantity, ret.transactionID, "Dashboard");
			}
			return;
		}
	},
	updateKeyPrice: function(){
		var self = this;
		var discountWrapper = $('.group-keys-discount');
		var noDiscountWrapper = $('#group-keys-no-discount');
		var standardDiscountsTable = $('#wfDiscountsTable');
		var numElem = jQuery('#element_numKeys');
		var numYearsElem = jQuery('#element_numYears');
		var ppkElem = jQuery('#element_pricePerKey');
		var ppkDisplayElem = jQuery('#display_pricePerKey');
		var totalElem = jQuery('#element_totalPrice');
		var totalDisplayElem = jQuery('#display_totalPrice');
		var discountElem = jQuery('#display_discount');
		var totalPriceNoDiscount,
			annualPriceNoDiscount,
			count,
			totalPrice,
			annualPricePerKey
			;

		var numberOfKeys = parseInt(numElem.val());
		var numberOfYears = parseInt(numYearsElem.val());

		// Has a group discount
		if (this.groupedDiscountKeys &&
			numberOfYears in this.groupedDiscountKeys
		) {
			discountWrapper.show();
			noDiscountWrapper.hide();
			standardDiscountsTable.hide();
			count = self.groupedDiscountKeys[numberOfYears].length;
		} else {
			noDiscountWrapper.show();
			standardDiscountsTable.show();
			discountWrapper.hide();
		}
		if(/^\d+$/.test(numberOfKeys) && numberOfKeys > 0){
			if(numberOfKeys <= 1000){
				annualPricePerKey = this.calcAnnualPrice(numberOfKeys, numberOfYears); //Price in cents
				totalPrice = annualPricePerKey * numberOfKeys * numberOfYears;
				if (count) {
					annualPriceNoDiscount = annualPricePerKey; //price per key per year
					totalPriceNoDiscount = totalPrice;

					// Calc total keys in past 5 days to get discounted price per key
					annualPricePerKey = this.calcAnnualPrice(numberOfKeys + self.groupedDiscountKeys[numberOfYears].length, numberOfYears); //price per key per year in cents
					// Calc total based on discounted price per keys * number of year
					totalPrice = annualPricePerKey * numberOfKeys * numberOfYears;
				}

				totalPriceNoDiscount = totalPriceNoDiscount || totalPrice;
				annualPriceNoDiscount = annualPriceNoDiscount || annualPricePerKey;
				count = count || 0;

				ppkElem.val('$' + this.currencyRound(annualPricePerKey / 100, 2).toFixed(2));
				ppkDisplayElem.html(ppkElem.val());
				totalElem.val('$' + this.currencyRound(totalPrice / 100, 2).toFixed(2));
				totalDisplayElem.html(totalElem.val());
				jQuery('#priceSummary').html('Calculation: $' + this.currencyRound(annualPricePerKey / 100, 2).toFixed(2) + ' per key X ' + numberOfKeys + ' Keys X ' + numberOfYears + ' Years = $' + this.currencyRound(totalPrice / 100, 2).toFixed(2));

				var baseKeyPrice = this.calcAnnualPrice(1, 1);
				if (baseKeyPrice == annualPricePerKey) {
					discountElem.html('');
				}
				else {
					var percentage = (100 * (1 - (annualPricePerKey / baseKeyPrice))).toFixed(2);
					discountElem.html("Discount: " + percentage + "%");
				}

				var self = this;
				$('[data-keys]').each(function() {
					var el = $(this);
					switch (el.attr('data-keys')) {
						case 'count':
							el.text(count);
							break;
						case 'keysTerm':
							el.text('key' + (count == 1 ? '' : 's'));
							break;
						case 'annualPrice':
							el.text('$' + self.currencyRound(annualPricePerKey / 100, 2).toFixed(2));
							break;
						case 'annualPriceNoDiscount':
							el.text('$' + self.currencyRound(annualPriceNoDiscount / 100, 2).toFixed(2));
							break;
						case 'totalPrice':
							el.text('$' + self.currencyRound(totalPrice / 100, 2).toFixed(2));
							break;
						case 'totalPriceNoDiscount':
							el.text('$' + self.currencyRound(totalPriceNoDiscount / 100, 2).toFixed(2));
							break;
					}
				});
			} else {
				ppkElem.val('Contact us.');
				ppkDisplayElem.html(ppkElem.val());
				totalElem.val('Contact us.');
				totalDisplayElem.html(totalElem.val());

				$('[data-keys]').each(function() {
					var el = $(this);
					switch (el.attr('data-keys')) {
						case 'annualPrice':
							el.text('Contact us.');
							break;
						case 'annualPriceNoDiscount':
							el.text('');
							break;
						case 'totalPrice':
							el.text('Contact us.');
							break;
						case 'totalPriceNoDiscount':
							el.text('');
							break;
					}
				});
			}
		} else {
			ppkElem.val("");
			ppkDisplayElem.html(ppkElem.val());
			totalElem.val("");
			totalDisplayElem.html(totalElem.val());
			discountElem.html('');
		}
	},
	calcTotalPrice: function(numberOfKeys, numberOfYears) {
		return this.calcAnnualPrice(numberOfKeys, numberOfYears) * numberOfKeys * numberOfYears; //Price in cents
	},
	calcAnnualPrice: function(numberOfKeys, numberOfYears) {
		var totalAnnualPriceCalc = 0;
		for (var i = 1; i <= numberOfKeys; i++) {
			for (var j = 0; j < WFKVars.pricing.length; j++) {
				var fromRange = WFKVars.pricing[j][0];
				var toRange = WFKVars.pricing[j][1];
				if (i >= fromRange && i <= toRange) {
					var price = this.currencyRound(WFKVars.pricing[j][2] * (1 - WFKVars.pricing[j][numberOfYears + 2]), 0);
					totalAnnualPriceCalc += price;
					break;
				}
			}
		}
		totalAnnualPriceCalc = this.currencyRound(totalAnnualPriceCalc / numberOfKeys, 0);
		return totalAnnualPriceCalc; //Price in cents
	},
	removeCards: function(){
		jQuery('#cardOnFile').fadeOut();
		this.ajax('wfRemoveCards', { }, function(ret){
			//Any ret.error is handled by the ajax function
			});
	},
	buyKeys: function(){
		var self = this;
		this.ajax('wfHaveCardOnFile', {}, function(res){
			if (res.groupedDiscountKeys) {
				self.groupedDiscountKeys = res.groupedDiscountKeys;
			}
			var par = {};
			if(res.yes){
				par = {
					cardLastFour: res.cardLastFour,
					haveCard: true
				};
			} else {
				par = { haveCard: false };
			}
			self.showModal(
				jQuery('#wfNoKeysBuyKeysTmpl').tmpl(par),
				function(){
					self.initKeyPrice();
					jQuery('select').customSelect().width('100%');

					(function($){
						paypal.Button.render({
							env: (WFKVars.paypalSandbox ? 'sandbox' : 'production'),

							style: {
								size: 'small',
									color: 'silver',
									shape: 'rect'
							},

							payment: function(resolve, reject) {
								if (self.cimPurchaseBusy) { return; }
								self.cimPurchaseBusy = true;
								$('#cimAjax').show();
								self.ajax('wfPayPalPrePurchase', {
										pricePerKey: $('#element_pricePerKey').val(),
										totalPrice: $('#element_totalPrice').val(),
										numKeys: $('#element_numKeys').val(),
										numYears: $('#element_numYears').val()
									},
									function(ret) {
										if (ret.err) {
											self.cimPurchaseBusy = false;
											$('#cimAjax').hide();
											self.showModal($('#wfErrTmpl').tmpl(ret));
											reject(ret.err);
											return;
										}
										else if (ret.ok) {
											resolve(ret.paymentID);
											return;
										}
									});
							},

							onAuthorize: function(data) {
								self.finalizePayPalPremiumKey(data.paymentID, data.payerID, function(ret) {
									self.cimPurchaseBusy = false;
									jQuery('#cimAjax').hide();

									if (ret.err) {
										self.showModal($('#wfErrTmpl').tmpl(ret));
										return;
									}
									else if (ret.ok) {
										self.loadKeys();
										self.showModal($('#wfThanksForPurchaseTmpl').tmpl(ret));
										self.cimPurchaseBusy = false;
										if (ret.logAnalytics) {
											self.logAnalyticsTransaction("More API Keys", "More API Keys", ret.timePeriod, ret.totalPrice, ret.quantity, ret.transactionID, "Dashboard");
										}
										return;
									} else {
										alert("An error occurred. You can try resubmitting your form or try reloading this page and then starting over.");
										return;
									}
								});
							},

							onCancel: function(data) {
								self.cimPurchaseBusy = false;
								jQuery('#cimAjax').hide();
							},

							onError: function(data) {
								self.cimPurchaseBusy = false;
								jQuery('#cimAjax').hide();
							}

						}, '#payPalWrapper');
					})(jQuery);
				},
				'modal700'
			);
		});
	},
	finalizePayPalPremiumKey: function(paymentID, payerID, callback) {
		var self = this;
		this.ajax('wfPayPalPurchase', {paymentID: paymentID, payerID: payerID}, function(ret) {
			typeof callback == 'function' && callback(ret);
		});
	},
	getSelectedKeys: function(className){
		var selected = new Array();
		jQuery('input.' + className + ':checked').each(function() {
			selected.push(jQuery(this).attr('name'));
			});
		return selected;
	},
	resetKeys: function(){
		var selected = this.getSelectedKeys('wf_checkbox');
		if(selected.length < 1){
			this.showModal(jQuery('#wfErrTmpl').tmpl({ err: "You did not select any API keys." }));
			return;
		}
		var self = this;
		this.ajax('wfResetKeys', {
			selected: selected
			}, function(ret){
				self.loadKeys();
			});
	},
	changeAutoRenew: function(renew){
		var selected = this.getSelectedKeys('wf_checkbox');
		if(selected.length < 1){
			this.showModal(jQuery('#wfErrTmpl').tmpl({ err: "You did not select any API keys." }));
			return;
		}
		var self = this;
		this.ajax('wfChangeAutoRenew', {
			selected: selected,
			renew: renew
			}, function(ret){
				self.loadKeys();
			});
	},
	buyMoreTime: function(){
		var self = this;
		var selected = this.getSelectedKeys('wf_checkbox');
		if(selected.length < 1){
			this.showModal(jQuery('#wfErrTmpl').tmpl({ err: "You did not select any API keys." }));
			return;
		}

		this.ajax('wfCalcRenewPrice', {
			numYears: 3,
			selected: selected,
			newKeys: jQuery('#addNewKeys').val()
			}, function(ret){
				if(ret.ok){
					self.showModal(jQuery('#wfBuyMoreTimeTmpl').tmpl({ haveCardOnFile: ret.haveCardOnFile, totalKeys: selected.length, cardLastFour: ret.cardLastFour }), function(){
						jQuery('#perKeyPrice').val('$' + ret.perKeyPrice);
						jQuery('#renewPrice').val('$' + ret.totalPrice);
					});
				} else if(ret.noCardOnFile){
					self.showModal(jQuery('#wfNoCardOnFileTmpl').tmpl());
				} else if(ret.noneRenewable){
					self.showModal(jQuery('#wfErrTmpl').tmpl({ err: "Some or all of the keys you selected can be renewed because they expire more than 5 years from now." }));
				} else {
					self.showModal(jQuery('#wfErrTmpl').tmpl({ err: "We received an invalid response from Wordfence." }));
				}
			}
		);
	},
	calcRenewPrice: function(){
		var selected = this.getSelectedKeys('wf_checkbox');
		this.ajax('wfCalcRenewPrice', {
			numYears: jQuery('#renewNumYears').val(),
			selected: selected,
			newKeys: (/^\d+$/.test(jQuery('#addNewKeys').val()) ? jQuery('#addNewKeys').val() : 0)
			},

				function(ret){
				if ((jQuery('#addNewKeys').val()) > 1000) {
				jQuery('#errorMsg_addNewKeys').html('Please email billing@wordfence.com to purchase more than 1000 keys.').show();
				jQuery('#addNewKeys').val(1000);
			} else {
				jQuery('#errorMsg_addNewKeys').empty();
					jQuery('#renewPrice').val('$' + ret.totalPrice);
					jQuery('#perKeyPrice').val('$' + ret.perKeyPrice);
				}
			}
			);
	},
	buyMoreTimeProcess: function(){
		if(this.buyMoreTimeBusy){ return; }
		this.buyMoreTimeBusy = true;
		var selected = this.getSelectedKeys('wf_checkbox');
		if(selected.length < 1){ return; }

		var self = this;
		this.ajax('wfBuyMoreTime', {
			selected: selected,
			numYears: jQuery('#renewNumYears').val(),
			newKeys: jQuery('#addNewKeys').val(),
			priceShown: jQuery('#renewPrice').val()
			}, function(ret){
				self.buyMoreTimeBusy = false;
				if(ret.ok){
					self.loadKeys();
					self.showModal(jQuery('#wfMsgTmpl').tmpl({ heading: "Your purchase was successful.", body: "Thanks for choosing Wordfence. We have renewed the selected license keys and added any new keys if you requested them." }));
					if(ret.logAnalytics){
						self.logAnalyticsTransaction("Renew Keys", "Renew Keys", ret.timePeriod, ret.totalPrice, ret.quantity, ret.transactionID, "Dashboard");
					}
					return;
				} else if(ret.err) {
					self.showModal(jQuery('#wfErrTmpl').tmpl({ err: ret.err }));
					return;
				} else {
					self.showModal(jQuery('#wfErrTmpl').tmpl({ err: "We could not complete your purchase. An unknown error occurred." }));
					return;
				}
			});
	},
	loadKeys: function(){
		var self = this;
		this.ajax('wfLoadKeys', {
			sort: this.keySort,
			sortOrder: this.keySortOrder
			}, function(res){ self.doneLoadKeys(res); });
	},
	doneLoadKeys: function(res){
		var self = this;

		jQuery('#wfKeyListDiv').hide().empty();
		if((! res.wfKeys) || res.wfKeys.length < 1){
			return;
		}
		jQuery('#wfKeyListTmpl').tmpl(res).appendTo('#wfKeyListDiv');

		jQuery('.wfFullKeyLink').unbind().click(function(e){
			var wfKeyContentTarget = jQuery(this).attr('href');
			var wfKeyContent = jQuery('#' + wfKeyContentTarget).first().html();
			self.showModal(wfKeyContent);
			e.preventDefault();
		});

		jQuery('.wfSortArrow').empty();
		if(this.keySortOrder == 'asc'){
			jQuery('#wfSortArrow_' + this.keySort).html('&#x25BC;');
		} else {
			jQuery('#wfSortArrow_' + this.keySort).html('&#x25B2;');
		}

		jQuery('#wfKeyListDiv').fadeIn();
	},
	ajax: function(action, data, cb){
		jQuery('#wfAjaxLoading').show();
		data['action'] = action;
		data['cacheBuster'] = new Date().getTime();
		jQuery.ajax({
			type: 'POST',
			url: WFKVars.ajaxURL,
			dataType: "json",
			data: data,
			success: function(json){
				jQuery('#wfAjaxLoading').hide();
				if(json.error){
					alert(json.error);
				} else {
					cb(json);
				}
			},
			error: function(obj, text, err){
				throw(err);
				}
			});
	},
	clearAllErrors: function(){
		this.haveError = false;
		jQuery('p.error').empty();
		jQuery('li.error').removeClass('error');
		jQuery('#error_message').hide();
	},
	showGlobalError: function(){
		jQuery('#error_message').show();
		jQuery('html, body').animate({
		         scrollTop: jQuery("#error_message").offset().top
			      }, 2000);
	},
	validateSignup: function(isPayPal, successCallback, failureCallback) {
		isPayPal = !!isPayPal;
		this.clearAllErrors();
		var mode = jQuery('#element_mode').val();
		if (mode == 'signup') {
			var fields = {required: ['mode', 'firstName', 'lastName', 'email', 'username', 'passwd1', 'numKeys', 'numYears', 'totalPrice', 'pricePerKey'],
						  optional: []};
			if (!isPayPal) {
				fields.required.push.apply(fields.required, ['cardNumber', 'cardExpiry', 'cardCode', 'country']);
				fields.optional.push.apply(fields.optional, ['firstNameCard', 'lastNameCard', 'zip', 'vat']);
			}
		}
		else if (mode == 'update') {
			var fields = {required: ['mode', 'cardNumber', 'cardExpiry', 'cardCode', 'country'],
						  optional: ['firstNameCard', 'lastNameCard', 'zip', 'vat']};
		}
		else {
			alert("Invalid mode given.");
		}
		var data = {isPayPal: isPayPal ? 1 : 0};
		for (var i = 0; i < fields.required.length; i++) {
			var k = fields.required[i];
			data[k] = jQuery('#element_' + k).val();
			if(! /[a-zA-Z0-9]+/.test(data[k])){
				this.addError(k, "This field is required.");
			}
		}

		if (!isPayPal) {
			var requiresZIP = !!jQuery('#element_country_' + data['country']).data('postal').length;
			if (requiresZIP) {
				data['zip'] = jQuery('#element_zip').val();
				if (!/[a-zA-Z0-9]+/.test(data['zip'])) {
					this.addError('zip', "This field is required.");
				}
			}
			var wantsVAT = !!jQuery('#element_country_' + data['country']).data('vat');
			if (wantsVAT) {
				data['vat'] = jQuery('#element_vat').val();
			}
		}

		if(this.haveError){
			this.showGlobalError();
			typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
			return;
		}

		if(mode == 'signup'){
			if(! /.+\@[^\.]+\.[^\.]+/.test(data['email'])){
				this.addError('email', "Please enter a valid email address.");
			}
			if(/\d+/.test(data['numKeys'])){
				if(data['numKeys'] > 1000){
					this.addError('numKeys', "Sorry but you need to contact us if you want to order more than 1000 keys.");
				}
			} else {
				this.addError("numKeys", "Please enter how many API keys you would like to purchase.");
			}
		}

		if (!isPayPal) {
			if (!jQuery.payment.validateCardNumber(jQuery('#element_cardNumber').val())) {
				this.addError('cardNumber', "Please enter a valid credit card number.");
			}
			var cardExpiry = jQuery('#element_cardExpiry').payment('cardExpiryVal');
			if (!jQuery.payment.validateCardExpiry(cardExpiry.month, cardExpiry.year)) {
				this.addError('cardExpiry', "Please enter a valid expiration date.");
			}
			if (!jQuery.payment.validateCardCVC(jQuery('#element_cardCode').val(), jQuery.payment.cardType(jQuery('#element_cardNumber').val()))) {
				this.addError('cardCode', "Please enter a valid card code.");
			}
		}

		if (this.haveError) {
			this.showGlobalError();
			typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
			return;
		}

		var self = this;
		jQuery('#wfSignupAjaxLoading').show();
		this.ajax('wfValidateSignup', data, function(ret) {
			jQuery('#wfSignupAjaxLoading').hide();
			if (ret.haveErrors) {
				for (var i = 0; i < ret.errors.length; i++) {
					self.addError(ret.errors[i][0], ret.errors[i][1]);
				}
				self.showGlobalError();
				typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
				return;
			}
			else if (ret.ok) {
				if (!isPayPal) {
					if (ret.logAnalytics) {
						self.logAnalyticsTransaction("New API Key", "New API Key", ret.timePeriod, ret.price, ret.quantity, ret.transactionID, "Wordfence Signup");
						self.logOptimizely('newPurchases', ret.price * 100);
						setTimeout(function(){
							window.location.href = ret.destination;
						}, 1000); //Give analytics time to log
					}
					else {
						window.location.href = ret.destination;
					}
				}
				typeof successCallback == 'function' && successCallback(ret);
				return;
			}
			else {
				alert("An error occurred. You can try resubmitting your form. Or try reloading this page and then starting over.");
				typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
				return;
			}
			});
	},
	useCardOnFile: function() {
		return jQuery('form.checkout-form input[name=element_cardOnFile]:checked').val() == '1';
	},
	validateCheckout: function (isPayPal, successCallback, failureCallback) {
		this.clearAllErrors();

		isPayPal = !!isPayPal;
		var mode = jQuery('#element_mode').val();

		if (mode === 'renewal') {
			var fields = {required: ['mode'], optional: ['autorenew']};
		} else {
			var fields = {required: ['quantity', 'mode'], optional: ['autorenew', 'priority']};
		}

		if (!jQuery('#element_userID').val()) { //Not logged in
			fields.required.push.apply(fields.required, ['firstName', 'lastName', 'email', 'username', 'passwd1']);
		}
		if (!isPayPal) {
			if (!this.useCardOnFile()) {
				fields.required.push.apply(fields.required, ['cardNumber', 'cardExpiry', 'cardCode', 'country']);
			}
			fields.optional.push.apply(fields.optional, ['zip', 'vat']);
		}

		var data = {};

		data['cardOnFile'] = this.useCardOnFile() ? 1 : 0;
		if (wfKeys.surgeMultiplier) {
			data['surgeMultiplier'] = wfKeys.surgeMultiplier;
		}

		for (var i = 0; i < fields.optional.length; i++) {
			var k = fields.optional[i];
			var elemID = '#element_' + k;
			data[k] = 0;
			if (!jQuery(elemID).is(':checkbox') || jQuery(elemID).is(':checked')) {
				data[k] = jQuery(elemID).val();
			}
		}

		for (var i = 0; i < fields.required.length; i++) {
			var k = fields.required[i];
			data[k] = jQuery('#element_' + k).val();
			if (! /[a-zA-Z0-9]+/.test(data[k])) {
				this.addError(k, "This field is required.");
			}
		}

		if (!jQuery('#element_userID').val()) { //Not logged in
			if (!/.+\@[^\.]+\.[^\.]+/.test(data['email'])) {
				this.addError('email', "Please enter a valid email address.");
			}
		}

		if (mode === 'renewal') {
			data['keys'] = [];
			jQuery('.wf-renewal-checkbox:checked').each(function() {
				data['keys'].push(jQuery(this).data('id'));
			});
			if (!data['keys'].length) {
				this.addError('paymentGeneral', 'Please select at least one API key to renew.');
			}
		}

		if (this.haveError) {
			this.showGlobalError();
			typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
			return false;
		}

		if (isPayPal) {
			jQuery('.checkout-form .btn').attr('disabled', true);
			jQuery('#payPalWrapper').attr('disabled', true);
			jQuery('.checkout-form .working').show();

			var self = this;

			this.ajax('wfCheckoutPayPal', data, function(ret) {
				if (ret.haveErrors) {
					jQuery('.checkout-form .btn').attr('disabled', false);
					jQuery('#payPalWrapper').attr('disabled', false);
					jQuery('.checkout-form .working').hide();
					
					if (ret.surgeMultiplierChanged && wfKeys.updateTotals) {
						wfKeys.updateTotals();
					}

					for (var i = 0; i < ret.errors.length; i++) {
						self.addError(ret.errors[i][0], ret.errors[i][1]);
					}
					self.showGlobalError();
					typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
					return;
				}
				else if(ret.ok){
					typeof successCallback == 'function' && successCallback(ret);
					return;
				}
				else {
					jQuery('.checkout-form .btn').attr('disabled', false);
					jQuery('#payPalWrapper').attr('disabled', false);
					jQuery('.checkout-form .working').hide();

					alert("An error occurred. You can try resubmitting your form. Or try reloading this page and then starting over.");
					typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
					return;
				}
			});

			return false;
		}

		if (!this.useCardOnFile()) {
			var requiresZIP = !!jQuery('#element_country_' + data['country']).data('postal').length;
			if (requiresZIP) {
				data['zip'] = jQuery('#element_zip').val();
				if (!/[a-zA-Z0-9]+/.test(data['zip'])) {
					this.addError('zip', "This field is required.");
				}
			}

			var wantsVAT = !!jQuery('#element_country_' + data['country']).data('vat');
			if (wantsVAT) {
				data['vat'] = jQuery('#element_vat').val();
			}

			if (this.haveError) {
				this.showGlobalError();
				return false;
			}

			if (!jQuery.payment.validateCardNumber(jQuery('#element_cardNumber').val())) {
				this.addError('cardNumber', "Please enter a valid credit card number.");
			}
			var cardExpiry = jQuery('#element_cardExpiry').payment('cardExpiryVal');
			if (!jQuery.payment.validateCardExpiry(cardExpiry.month, cardExpiry.year)) {
				this.addError('cardExpiry', "Please enter a valid expiration date.");
			}
			if (!jQuery.payment.validateCardCVC(jQuery('#element_cardCode').val(), jQuery.payment.cardType(jQuery('#element_cardNumber').val()))) {
				this.addError('cardCode', "Please enter a valid card code.");
			}
		}

		if (this.haveError) {
			this.showGlobalError();
			typeof failureCallback == 'function' && failureCallback('There were errors processing your request.');
			return false;
		}

		var self = this;
		jQuery('.checkout-form .btn').attr('disabled', true);
		jQuery('#payPalWrapper').attr('disabled', true);
		jQuery('.checkout-form .working').show();

		this.ajax('wfCheckout', data, function(ret) {
			jQuery('.checkout-form .btn').attr('disabled', false);
			jQuery('#payPalWrapper').attr('disabled', false);
			jQuery('.checkout-form .working').hide();

			if (ret.haveErrors) {
				if (ret.surgeMultiplierChanged && wfKeys.updateTotals) {
					wfKeys.updateTotals();
				}
				
				for (var i = 0; i < ret.errors.length; i++) {
					self.addError(ret.errors[i][0], ret.errors[i][1]);
				}
				self.showGlobalError();
				return;
			} else if (ret.ok) {
				if (ret.logAnalytics) {
					// self.logAnalyticsTransaction("New API Key", "New API Key", ret.timePeriod, ret.price, ret.quantity, ret.transactionID, "Wordfence Signup");
					// self.logOptimizely('newPurchases', ret.price * 100);
					// setTimeout(function(){
					 	window.location.href = ret.destination;
					// }, 1000); //Give analytics time to log
				} else {
					window.location.href = ret.destination;
				}
				return;
			} else {
				alert("An error occurred. You can try resubmitting your form. Or try reloading this page and then starting over.");
				return;
			}
		});

		return false;
	},
	finalizePayPalSiteCleaning: function(paymentID, payerID) {
		var self = this;
		this.ajax('wfFinalizePayPal', {paymentID: paymentID, payerID: payerID}, function(ret) {
			jQuery('.checkout-form .btn').attr('disabled', false);
			jQuery('#payPalWrapper').attr('disabled', false);
			jQuery('.checkout-form .working').hide();

			if (ret.haveErrors) {
				for (var i = 0; i < ret.errors.length; i++) {
					self.addError(ret.errors[i][0], ret.errors[i][1]);
				}
				self.showGlobalError();
				return;
			} else if(ret.ok){
				if(ret.logAnalytics){
					// self.logAnalyticsTransaction("New API Key", "New API Key", ret.timePeriod, ret.price, ret.quantity, ret.transactionID, "Wordfence Signup");
					// self.logOptimizely('newPurchases', ret.price * 100);
					// setTimeout(function(){
					window.location.href = ret.destination;
					// }, 1000); //Give analytics time to log
				} else {
					window.location.href = ret.destination;
				}
				return;
			} else {
				alert("An error occurred. You can try resubmitting your form. Or try reloading this page and then starting over.");
				return;
			}
		});
	},
	finalizePayPalSiteAudit: function(paymentID, payerID) {
		var self = this;
		this.ajax('wfFinalizePayPal', {paymentID: paymentID, payerID: payerID}, function(ret) {
			jQuery('.checkout-form .btn').attr('disabled', false);
			jQuery('#payPalWrapper').attr('disabled', false);
			jQuery('.checkout-form .working').hide();

			if (ret.haveErrors) {
				for (var i = 0; i < ret.errors.length; i++) {
					self.addError(ret.errors[i][0], ret.errors[i][1]);
				}
				self.showGlobalError();
				return;
			} else if(ret.ok){
				if(ret.logAnalytics){
					// self.logAnalyticsTransaction("New API Key", "New API Key", ret.timePeriod, ret.price, ret.quantity, ret.transactionID, "Wordfence Signup");
					// self.logOptimizely('newPurchases', ret.price * 100);
					// setTimeout(function(){
					window.location.href = ret.destination;
					// }, 1000); //Give analytics time to log
				} else {
					window.location.href = ret.destination;
				}
				return;
			} else {
				alert("An error occurred. You can try resubmitting your form. Or try reloading this page and then starting over.");
				return;
			}
		});
	},
	finalizePayPalRenewal: function(paymentID, payerID) {
		var self = this;
		var keys = [];

		jQuery('.wf-renewal-checkbox:checked').each(function() {
			keys.push(jQuery(this).data('id'));
		});

		this.ajax('wfFinalizePayPal', {paymentID: paymentID, payerID: payerID, keys: keys}, function(ret) {
			jQuery('.checkout-form .btn').attr('disabled', false);
			jQuery('#payPalWrapper').attr('disabled', false);
			jQuery('.checkout-form .working').hide();

			if (ret.haveErrors) {
				for (var i = 0; i < ret.errors.length; i++) {
					self.addError(ret.errors[i][0], ret.errors[i][1]);
				}
				self.showGlobalError();
				return;
			} else if(ret.ok){
				window.location.href = ret.destination;
				return;
			} else {
				alert("An error occurred. You can try resubmitting your form. Or try reloading this page and then starting over.");
				return;
			}
		});
	},
	logOptimizely: function(eventName, priceInCents){
		window.optimizely = window.optimizely || [];
		window.optimizely.push(['trackEvent', eventName, {'revenue': priceInCents}]);
	},
	logAnalyticsTransaction: function(name, category, variant, price, quantity, transactionID, affiliation){
		try {
		 //ga('create', 'UA-248353-24');
		 ga('require', 'ec');
		 ga('ec:addProduct', {
				 'id': '1',
				 'name': name, //"New API Key"
				 'category': category, //"New API Key"
				 'brand': 'Wordfence',
				 'variant': variant, //2 year
				 'price': this.currencyRound((parseFloat(price) / quantity), 2), //This is price per unit of product.
				 'quantity': quantity //1
				 });

		 // Transaction level information is provided via an actionFieldObject.
		 ga('ec:setAction', 'purchase', {
				 'id': transactionID,
				 'affiliation': affiliation, //e.g. Wordfence Initial Signup. Or: Wordfence Manage API Keys
				 'revenue': price
				 });

		 ga('send', 'pageview');     // Send transaction data with initial pageview.
		}
		catch (err) {
			//Do nothing
		}
	},
	unHoldCard: function(profileID){
		var self = this;
		this.ajax('wfUnHoldCard', {
			profileID: profileID
			}, function(ret){
				if(ret.ok){
					self.showModal("<div style=\"margin: 5px;\"><h2>Card Hold Removed</h2><p>The hold on your card has been removed. Any keys that need to be renewed will be auto-renewed within 24 hours.<br /><br /><center><input type=\"button\" value=\"Click here to refresh this page now\" onclick=\"location.reload(true);\" /></center></p></div>");
				} else {
					alert("An error occurred. Try refreshing this page.");
				}
			});
	},
	addError: function(k, msg){
		jQuery('#errorMsg_' + k).html(msg);
		jQuery('#li_' + k).addClass('error');
		this.haveError = true;
	},
	unholdCard: function(userID){
		var self = this;
		this.showLoading();
		this.ajax('wfUnholdCard', {
			userID: userID
			}, function(ret){
				self.removeLoading();
				if(ret.errorMsg){
					alert(ret.errorMsg);
				} else if(ret.ok){
					location.reload(true);
				}
			});
	},
	adminOpKeys: function(userID, op, className){
		selected = this.getSelectedKeys(className);
		this.showLoading();
		var self = this;
		this.ajax('wfAdminOpKeys', {
			selected: selected,
			op: op,
			userID: userID
			}, function(ret){
				self.removeLoading();
				if(ret.errorMsg){
					self.showModal("<div><h2>Error:</h2><p>" + ret.errorMsg + "</p></div>");
				} else {
					location.reload(true);
				}
			});
	},
	suggestPrice: function(userid, totalPrice, numKeys){
		//jQuery('#priceParent' + userid + ' .autoRenewPrice').val((totalPrice / numKeys).toFixed(2));
		var arr = {};
		jQuery('#priceParent' + userid + ' .transMD5').each(function(idx, el){
			if(! arr.hasOwnProperty(el.innerHTML)){
				arr[el.innerHTML] = [];
			}
			//key id, price,
			arr[el.innerHTML].push({
				keyID: el.id,
				price: jQuery('#price' + el.id).html(),
				years: jQuery('#years' + el.id).html()
				});
		});
		for(var md5 in arr){
			var price = arr[md5][0].price / arr[md5].length / arr[md5][0].years;
			for(var i = 0; i < arr[md5].length; i++){
				jQuery('#autoRenewPrice' +  arr[md5][i].keyID).val(this.currencyRound(price, 2));
			}
		}
	},
	saveAutoRenew: function(userid){
		var data = [];
		var hasEmpty = false;
		jQuery('#priceParent' + userid + ' .autoRenewPrice').each(function(idx, el){
			var keyID = el.id.replace('autoRenewPrice', '');
			var price = jQuery(el).val();
			if(price == 0 || price == '0.00' || (! /^[\d\.]+/.test(price)) ){
				hasEmpty = true;
			}
			data.push(keyID + ';' + price);
		});
		if(hasEmpty){
			alert("One of the auto-renew prices for this user that you've entered is either empty or contains illegal characters.");
			return;
		}
		this.ajax('wfSetRenewPrice', {
			userid: userid,
			data: data
			}, function(ret){
				if(ret.ok && ret.userid){
					jQuery('#fullEnc' + ret.userid).fadeOut();
					return;
				} else if(ret.err){
					alert(ret.err);
				} else {
					alert("We got an invalid response while saving this data.");
				}
			});
	}
}
}
	jQuery(document).ready(function() { (function($){
		wfKeys.init($);
	})(jQuery) });
})(jQuery);
}); // End Raven.context()
